function Building() {
  
  this.type;
  this.level;
  
  this.id;
  this.x;
  this.y;

  this.malt = 0;
  this.hops = 0;
  this.water = 0;
  this.wort = 0;
  this.kegs = 0;
  this.bottles = 0;
  this.crates = 0;
  
  this.maltLimit = 0;
  this.hopsLimit = 0;
  this.waterLimit = 0;
  this.wortLimit = 0;
  this.kegsLimit = 0;
  this.bottlesLimit = 0;
  this.cratesLimit = 0;
  
  this.maltOrdered = 0;
  this.hopsOrdered = 0;
  this.waterOrdered = 0;
  this.wortOrdered = 0;
  this.kegsOrdered = 0;
  this.bottlesOrdered = 0;
  this.cratesOrdered = 0;
  
  this.maltReserved = 0;
  this.hopsReserved = 0;
  this.waterReserved = 0;
  this.wortReserved = 0;
  this.kegsReserved = 0;
  this.bottlesReserved = 0;
  this.cratesReserved = 0;
  
  this.producing = false;
  this.progress = 0;
  this.speed = 0;
  
  this.hasParticleSystem;
  this.particleSystem;
  
  this.displayItems = {
    BarleyField : { malt : 3 },
    HopsField : { hops : 3 },
    WaterPump : { water : 3 },
    Brewing : { malt : 1, hops : 1, water : 2, wort : 3 },
    Fermentation : { wort : 1, kegs : 3 },
    Bottling : { kegs : 1, bottles : 3 },
    CrateMachine : { bottles : 1, crates : 3 }
  };
  
  this.itemLocations = [
    [{ x : 15, y : 55 }, { x : 13, y : 56 }, { x : 11, y : 57 }, { x :  9, y : 58 }, { x :  7, y : 59 }],
    [{ x : 18, y : 60 }, { x : 16, y : 61 }, { x : 14, y : 62 }, { x : 12, y : 63 }, { x : 10, y : 64 }],
    [{ x : 21, y : 65 }, { x : 19, y : 66 }, { x : 17, y : 67 }, { x : 15, y : 68 }, { x : 13, y : 69 }],
    [{ x : 58, y : 60 }, { x : 60, y : 61 }, { x : 62, y : 62 }, { x : 64, y : 63 }, { x : 66, y : 64 }]
  ];
  
  
  this.init = function(type, id, x, y, level, mapX, mapY) {
    this.type = type;
    this.id = id;
    this.x = x;
    this.y = y;
    this.level = level;
    
    if(this.type == "BarleyField") {
      this.speed = 10;
      this.maltLimit = 3;
      
    } else if(this.type == "HopsField") {
      this.speed = 10;
      this.hopsLimit = 3;
      
    } else if(this.type == "WaterPump") {
      this.speed = 5;
      this.waterLimit = 5;
      
    } else if(this.type == "Brewing") {
      this.speed = 10;
      this.maltLimit = 5;
      this.hopsLimit = 5;
      this.waterLimit = 5;
      this.wortLimit = 1;
      
      this.particleSystem = new ParticleSystem();
      this.particleSystem.setType(1);
      this.particleSystem.setEmitter(mapX + 38, mapY + 17);
      this.particleSystem.setV(-0.4, 0.4, -0.7, -0.8);
      this.particleSystem.setA(0.1, 0.1, 0.0, 0.1);
      this.particleSystem.setLife(30, 40);
      this.particleSystem.off();
      this.hasParticleSystem = true;
      
    } else if(this.type == "Fermentation") {
      this.speed = 20;
      this.wortLimit = 1;
      this.kegsLimit = 3;
      
    } else if(this.type == "Bottling") {
      this.speed = 2;
      this.kegsLimit = 3;
      this.bottlesLimit = 2;
      
    } else if(this.type == "CrateMachine") {
      this.speed = 3;
      this.bottlesLimit = 4;
      this.cratesLimit = 5;
    
    } else if(this.type == "Generator") {
      this.particleSystem = new ParticleSystem();
      this.particleSystem.setType(2);
      this.particleSystem.setEmitter(mapX + 38, mapY + 18);
      this.particleSystem.setV(-0.2, 0.2, -0.5, -1.0);
      this.particleSystem.setA(0.1, 0.1, 0.0, 0.1);
      this.particleSystem.setLife(20, 30);
      this.hasParticleSystem = true;
    }
  };
  
  
  this.update = function() {
    
    if(!this.producing) {
      if(this.type == "BarleyField") {
        if(this.malt < this.maltLimit) {
          this.producing = true;
        }
        
      } else if(this.type == "HopsField") {
        if(this.hops < this.hopsLimit) {
          this.producing = true;
        }
        
      } else if(this.type == "WaterPump") {
        if(this.water < this.waterLimit) {
          this.producing = true;
        }
        
      } else if(this.type == "Brewing") {
        if(this.malt >= 2 && this.hops >= 1 && this.water >= 2 && this.wort < this.wortLimit) {
          this.malt -= 2;
          this.hops -= 1;
          this.water -= 2;
          this.producing = true;
          this.particleSystem.on();
        }
        
      } else if(this.type == "Fermentation") {
        if(this.wort >= 1 && this.kegs < this.kegsLimit) {
          this.wort -= 1;
          this.producing = true;
        }
        
      } else if(this.type == "Bottling") {
        if(this.kegs >= 1 && this.bottles < this.bottlesLimit) {
          this.kegs -= 1;
          this.producing = true;
        }
        
      } else if(this.type == "CrateMachine") {
        if(this.bottles >= 4 && this.crates < this.cratesLimit) {
          this.bottles -= 4;
          this.producing = true;
        }
      }
    }
    
    if(this.producing) {
      this.progress += 1 / (30 * this.speed);
    
      if(this.progress >= 1) {
        this.producing = false;
        this.progress = 0;
        if(this.type == "BarleyField") {
          this.malt++;
          
        } else if(this.type == "HopsField") {
          this.hops++;
          
        } else if(this.type == "WaterPump") {
          this.water++;
          
        } else if(this.type == "Brewing") {
          this.wort++;
          this.particleSystem.off();
          
        } else if(this.type == "Fermentation") {
          this.kegs++;
          
        } else if(this.type == "Bottling") {
          this.bottles++;
          
        } else if(this.type == "CrateMachine") {
          this.crates++;
        }
        
      }
    }
  };
  
  
  this.draw = function() {
    var lotCoords = map.getLotCoords(this.x, this.y);
    var progress = 0;
    if(this.progress) {
      progress = Math.ceil(7 * this.progress) - 1;
    }
    img.drawSprite(this.type, lotCoords.x, lotCoords.y, 76, 76, progress, 0);
    
    var itemNumbers = {
      malt : this.malt,
      hops : this.hops,
      water : this.water,
      wort : this.wort,
      kegs : this.kegs,
      bottles : this.bottles,
      crates : this.crates
    };
    
    for(var itemType in this.displayItems[this.type]) {
      var placement = this.displayItems[this.type][itemType];
      for(var i = 0; i < itemNumbers[itemType]; i++) {
        var itemPos = this.itemLocations[placement][i];
        img.draw(itemType, lotCoords.x + itemPos.x - 5, lotCoords.y + itemPos.y - 5);
      }
    }
  };
  
  
  this.drawParticles = function() {
    if(this.hasParticleSystem) {
      this.particleSystem.draw();
    }
  };
  
  
}