function Employee() {
  
  this.x = 0;
  this.y = 0;
  this.dir = 0;
  
  this.speed = 3;
  this.vertSpeed = 2;
  
  this.destX = 0;
  this.destY = 0;
  
  this.walkOffsetX = 0;
  this.walkOffsetY = 0;
  this.dirPreference = 0;
  
  this.inventory = "";
  
  this.spawnOffset = false;
  
  this.transport;
  this.transportPhase = 0;
  
  
  this.init = function() {
    
  };
  
  
  this.spawnAtStart = function(startX, startY) {
    this.x = startX;
    this.y = startY;
    this.dir = 0;
    
    this.destX = startX;
    this.destY = startY;
    
    this.walkOffsetX = rand(-3, 3);
    this.walkOffsetY = rand(-3, 3);
    this.dirPreference = rand(0, 1);
  };
  
  
  this.spawn = function(startX, startY) {
    this.x = startX;
    this.y = startY + 100;
    this.dir = 0;
    
    this.spawnOffset = true;
    
    this.destX = startX;
    this.destY = startY;
    
    this.walkOffsetX = rand(-3, 3);
    this.walkOffsetY = rand(-3, 3);
    this.dirPreference = rand(0, 1);
  };
  
  
  this.update = function() {
    if(this.spawnOffset) {
      if(this.destY < this.y - this.vertSpeed) {
        this.y -= this.vertSpeed;
      } else {
        this.y = this.destY;
        this.spawnOffset = false;
      }
      return;
    }
    if(this.transportPhase == 0) { //idle
      if(map.hasNextTransport()) {
        this.transport = map.getNextTransport();
        var corners = map.getTwoCornersOfBuilding(this.transport.start);
        var distanceToLeftCorner = distance(this.x, this.y, corners.x1, corners.y1);
        var distanceToRightCorner = distance(this.x, this.y, corners.x2, corners.y2);
        if(distanceToLeftCorner < distanceToRightCorner) {
          this.destX = corners.x1;
          this.destY = corners.y1;
        } else {
          this.destX = corners.x2;
          this.destY = corners.y2;
        }
        this.transportPhase = 1;
      }
      
    } else if(this.transportPhase == 1 || this.transportPhase == 4) { //moving
      var arrived = false;
      if(this.dirPreference == 0) {
        if(this.destX > this.x + this.speed) {
          this.x += this.speed;
        } else if(this.destX < this.x - this.speed) {
          this.x -= this.speed;
        } else {
          this.x = this.destX;
          if(this.destY > this.y + this.vertSpeed) {
            this.y += this.vertSpeed;
          } else if(this.destY < this.y - this.vertSpeed) {
            this.y -= this.vertSpeed;
          } else {
            this.y = this.destY;
            this.transportPhase++;
            arrived = true;
          }
        }
      } else {
        if(this.destY > this.y + this.vertSpeed) {
          this.y += this.vertSpeed;
        } else if(this.destY < this.y - this.vertSpeed) {
          this.y -= this.vertSpeed;
        } else {
          this.y = this.destY;
          if(this.destX > this.x + this.speed) {
            this.x += this.speed;
          } else if(this.destX < this.x - this.speed) {
            this.x -= this.speed;
          } else {
            this.x = this.destX;
            this.transportPhase++;
            arrived = true;
          }
        }
      }
      if(arrived) {
        if(this.transportPhase == 2) {
          var destination = map.getLoadingPointOfBuilding(this.transport.start);
          this.destX = destination.x;
          this.destY = destination.y;
        } else {
          var destination = map.getDropoffPointOfBuilding(this.transport.end);
          this.destX = destination.x;
          this.destY = destination.y;
        }
      }
      
    } else if(this.transportPhase == 2 || this.transportPhase == 5) { // walk to building
      var distanceToDest = distance(this.x, this.y, this.destX, this.destY);
      if(distanceToDest > this.speed) {
        var angle = Math.atan2(this.x - this.destX, this.y - this.destY);
        this.x -= Math.sin(angle) * this.speed;
        this.y -= Math.cos(angle) * this.speed;
      } else {
        this.x = this.destX;
        this.y = this.destY;
        this.transportPhase++;
        if(this.transportPhase == 3) {
          this.getFromBuilding();
          var corners = map.getTwoCornersOfBuilding(this.transport.start);
          this.destX = corners.x2;
          this.destY = corners.y2;
        } else {
          this.giveToBuilding();
          var corners = map.getTwoCornersOfBuilding(this.transport.end);
          if(rand(0,1) == 1) {
            this.destX = corners.x1;
            this.destY = corners.y1;
          } else {
            this.destX = corners.x2;
            this.destY = corners.y2;
          }
        }
      }
      
    } else if(this.transportPhase == 3 || this.transportPhase == 6) { // walk away from building
      var distanceToDest = distance(this.x, this.y, this.destX, this.destY);
      if(distanceToDest > this.speed) {
        var angle = Math.atan2(this.x - this.destX, this.y - this.destY);
        this.x -= Math.sin(angle) * this.speed;
        this.y -= Math.cos(angle) * this.speed;
      } else {
        this.x = this.destX;
        this.y = this.destY;
        if(this.transportPhase == 3) {
          var corners = map.getTwoCornersOfBuilding(this.transport.end);
          var distanceToLeftCorner = distance(this.x, this.y, corners.x1, corners.y1);
          var distanceToRightCorner = distance(this.x, this.y, corners.x2, corners.y2);
          if(distanceToLeftCorner < distanceToRightCorner) {
            this.destX = corners.x1;
            this.destY = corners.y1;
          } else {
            this.destX = corners.x2;
            this.destY = corners.y2;
          }
          this.transportPhase = 4;
        } else {
          this.transportPhase = 0;
        }
      }
      
    }
  };
  
  
  this.getFromBuilding = function() {
    this.inventory = this.transport.ressource;
    if(this.inventory == "malt") {
      map.buildings[this.transport.start].maltReserved--;
      map.buildings[this.transport.start].malt--;
    } else if(this.inventory == "hops") {
      map.buildings[this.transport.start].hopsReserved--;
      map.buildings[this.transport.start].hops--;
    } else if(this.inventory == "water") {
      map.buildings[this.transport.start].waterReserved--;
      map.buildings[this.transport.start].water--;
    } else if(this.inventory == "wort") {
      map.buildings[this.transport.start].wortReserved--;
      map.buildings[this.transport.start].wort--;
    } else if(this.inventory == "keg") {
      map.buildings[this.transport.start].kegsReserved--;
      map.buildings[this.transport.start].kegs--;
    } else if(this.inventory == "bottle") {
      map.buildings[this.transport.start].bottlesReserved--;
      map.buildings[this.transport.start].bottles--;
    } else if(this.inventory == "crate") {
      map.buildings[this.transport.start].cratesReserved--;
      map.buildings[this.transport.start].crates--;
    }
  };
  
  
  this.giveToBuilding = function() {
    if(this.inventory == "malt") {
      map.buildings[this.transport.end].maltOrdered--;
      map.buildings[this.transport.end].malt++;
    } else if(this.inventory == "hops") {
      map.buildings[this.transport.end].hopsOrdered--;
      map.buildings[this.transport.end].hops++;
    } else if(this.inventory == "water") {
      map.buildings[this.transport.end].waterOrdered--;
      map.buildings[this.transport.end].water++;
    } else if(this.inventory == "wort") {
      map.buildings[this.transport.end].wortOrdered--;
      map.buildings[this.transport.end].wort++;
    } else if(this.inventory == "keg") {
      map.buildings[this.transport.end].kegsOrdered--;
      map.buildings[this.transport.end].kegs++;
    } else if(this.inventory == "bottle") {
      map.buildings[this.transport.end].bottlesOrdered--;
      map.buildings[this.transport.end].bottles++;
    } else if(this.inventory == "crate") {
      map.buildings[this.transport.end].cratesOrdered--;
      map.buildings[this.transport.end].crates++;
    }
    this.inventory = "";
  };
  
  
  this.draw = function() {
    var drawX = this.x + this.walkOffsetX - 10;
    var drawY = this.y + this.walkOffsetY - 20;
    img.drawSprite("Employee", drawX, drawY, 20, 25, 0, 0);
  };  
  
  
}