function Game() {
  
  this.width = 960;
  this.height = 496;
  
  this.interval;
  
  this.showInstructions = true;
  this.showWin = false;
  this.gotWin = false;
  
  
  this.init = function() {
    this.empty();
    img.loadLoadingScreen();
  };
  
  
  this.startLoading = function() {
    c.drawImage(img.loadingScreenImage, 0, 0);
    img.load();
  };
  
  
  this.endLoading = function() {
    this.startGame();
  };
  
  
  this.startGame = function() {
    
    map = new Map();
    map.init();
    
    panel = new Panel();
    panel.init();
    
    mouse.registerUpArea("instructions", 0, 0, this.width, this.height, function() {
      game.showInstructions = false;
      mouse.deleteUpArea("instructions");
    });
    
    this.startLoop();
  };
  
  
  this.startLoop = function() {
    this.interval = window.setInterval(function() {
      game.loop();
    }, 33);
  };
  
  
  this.loop = function() {
    this.update();
    this.draw();
  };
  
  
  this.update = function() {
    map.update();
  };
  
  
  this.draw = function() {
    
    this.empty();
    
    map.draw();
    
    panel.draw();
    
    if(this.showInstructions) {
      img.draw("instructions", 126, 114);
    }
    
    if(this.showWin) {
      img.draw("win", 126, 114);
    }
    
  };
  
  
  this.empty = function() {
    c.fillStyle = "#000";
    c.fillRect(0, 0, this.width, this.height);
  };

}