function Panel() {
  
  this.labels = {};
  
  this.money;
  
  this.power;
  
  this.employees;
  
  this.downOnEmployees = false;
  
  this.hintStep = 0;
  this.hintLine1;
  this.hintLine2;
  
  this.production;
  
  this.buildingButtons = [
    { type : "BarleyField",  x : 694, y : 95 },
    { type : "HopsField",    x : 782, y : 95 },
    { type : "WaterPump",    x : 870, y : 95 },
    { type : "Brewing",      x : 694, y : 230 },
    { type : "Fermentation", x : 782, y : 230 },
    { type : "Generator",    x : 870, y : 230 },
    { type : "Bottling",     x : 738, y : 365 },
    { type : "CrateMachine", x : 826, y : 365 }
  ];
  
  
  this.init = function() {
    this.registerClickables();
    
    this.initBuildButtonsLabels();
    
    this.money = new Numbers();
    this.money.position(275, 10);
    
    this.power = new Numbers();
    this.power.position(421, 10);
    
    this.employees = new Numbers();
    this.employees.position(574, 10);
    
    this.production = new Numbers();
    this.production.setSize("Large");
    this.production.center();
    this.production.position(825, 31);
    
    this.hintLine1 = new Text();
    this.hintLine1.position(348, 262 - 15);
    this.hintLine1.center();
    
    this.hintLine2 = new Text();
    this.hintLine2.position(348, 262 + 2);
    this.hintLine2.center();
  };
  
  
  this.initBuildButtonsLabels = function() {
    
    var buttonLabels = {
      BarleyField  : ["BARLEY", "FARM"],
      HopsField    : ["HOPS", "FARM"],
      WaterPump    : ["WATER", "PUMP"],
      Brewing      : ["BREWING", "KETTLE"],
      Fermentation : ["FERMENTATION", "TANK"],
      Generator    : ["GENERATOR"],
      Bottling     : ["BOTTLING", "LINE"],
      CrateMachine : ["CRATE FILLING", "MACHINE"]
    };
    
    var buttonCosts = {
      BarleyField  : "5",
      HopsField    : "5",
      WaterPump    : "10",
      Brewing      : "30",
      Fermentation : "25",
      Generator    : "10",
      Bottling     : "20",
      CrateMachine : "30"
    };
    
    var buttonPowers = {
      BarleyField  : "-1",
      HopsField    : "-1",
      WaterPump    : "-5",
      Brewing      : "-8",
      Fermentation : "-2",
      Generator    : "+40",
      Bottling     : "-6",
      CrateMachine : "-6"
    };
    
    for(var i in this.buildingButtons) {
      
      var button = this.buildingButtons[i];
      var buttonLabel = buttonLabels[button.type];
      
      this.labels["build" + button.type + "Price"] = new Text();
      this.labels["build" + button.type + "Price"].position(button.x + 24, button.y + 103);
      this.labels["build" + button.type + "Price"].text(buttonCosts[button.type]);
      
      this.labels["build" + button.type + "Power"] = new Text();
      this.labels["build" + button.type + "Power"].position(button.x + 58, button.y + 103);
      this.labels["build" + button.type + "Power"].text(buttonPowers[button.type]);
      
      if(buttonLabel.length == 1) {
        this.labels["build" + button.type] = new Text();
        this.labels["build" + button.type].position(button.x + 43, button.y + 71);
        this.labels["build" + button.type].center();
        this.labels["build" + button.type].text(buttonLabel[0]);
        
      } else {
        this.labels["build" + button.type + "1"] = new Text();
        this.labels["build" + button.type + "1"].position(button.x + 43, button.y + 71);
        this.labels["build" + button.type + "1"].center();
        this.labels["build" + button.type + "1"].text(buttonLabel[0]);
        this.labels["build" + button.type + "2"] = new Text();
        this.labels["build" + button.type + "2"].position(button.x + 43, button.y + 86);
        this.labels["build" + button.type + "2"].center();
        this.labels["build" + button.type + "2"].text(buttonLabel[1]);
      }
    }

  };
  
  
  this.registerClickables = function() {
    mouse.registerUpArea("startBuild", 696, 95, 258, 400, function() {
      for(var i in panel.buildingButtons) {
        var button = panel.buildingButtons[i];
        if(mouse.isOver(button.x, button.y, 86, 100)) {
          map.startBuildSelection(button.type);
        }
      }
    });
    
    mouse.registerDownArea("plusOne", 620, 5, 70, 24, function() {
      panel.downOnEmployees = true;
    });
    
    mouse.registerUpArea("plusOne", 620, 5, 70, 24, function() {
      panel.downOnEmployees = false;
      map.addEmployee();
    });
  };
  
  
  this.deleteClickables = function() {
    mouse.deleteUpArea("startBuild");
  };
  
  
  this.hint = function(line1, line2) {
    this.hintStep = 50;
    this.hintLine1.text(line1);
    this.hintLine2.text(line2);
  };
  
  
  this.draw = function() {
    
    img.draw("Panel", 0, 0);
    
    this.money.text(map.money.toString());
    this.money.draw();
    
    this.power.text(map.usedPower.toString() + " / " + map.totalPower.toString());
    this.power.draw();
    
    this.employees.text(map.employeesCounter.toString());
    this.employees.draw();
    
    for(var i in this.buildingButtons) {
      var button = this.buildingButtons[i];
      if(mouse.isOver(button.x, button.y, 86, 120)) {
        img.draw("PanelBuildRollover", button.x, button.y);
      }
    }
    
    if(map.crateTimes.length == 0) {
      img.drawSprite("production", 690, 0, 270, 85, 0, 0);
    } else {
      img.drawSprite("production", 690, 0, 270, 85, 0, 1);
      var timeSum = 0;
      for(var i in map.crateTimes) {
        timeSum += map.crateTimes[i];
      }
      var productionRate = timeSum / map.crateTimes.length;
      productionRate = Math.round(10 * productionRate) / 10;
      if(!game.gotWin && productionRate <= 10) {
        game.gotWin = true;
        game.showWin = true;
        mouse.registerUpArea("win", 0, 0, game.width, game.height, function() {
          game.showWin = false;
          mouse.deleteUpArea("win");
        });
      };
      this.production.text(productionRate.toString());
      this.production.draw();
    }
    
    for(var i in this.buildingButtons) {
      var button = this.buildingButtons[i];
      img.drawSprite(button.type, button.x + 5, button.y - 3, 76, 76, 0, 0);
      img.draw("coin", button.x + 4, button.y + 99);
      img.draw("power", button.x + 42, button.y + 99);
    }
    
    for(var i in this.labels) {
      this.labels[i].draw();
    }
    
    if(this.downOnEmployees) {
      if(mouse.isOver(620, 5, 70, 24)) {
        img.drawSprite("plusOne", 620, 5, 70, 24, 0, 2);
      } else {
        this.downOnEmployees = false;
        img.drawSprite("plusOne", 620, 5, 70, 24, 0, 0); 
      }
    } else {
      if(mouse.isOver(620, 5, 70, 24)) {
        img.drawSprite("plusOne", 620, 5, 70, 24, 0, 1);
      } else {
        img.drawSprite("plusOne", 620, 5, 70, 24, 0, 0);
      }
    }
    
    if(this.hintStep > 0) {
      this.hintStep--;
      if(this.hintStep < 15) {
        c.globalAlpha = this.hintStep / 15;
      }
      img.draw("hint", 223, 232);
      this.hintLine1.draw();
      this.hintLine2.draw();
      c.globalAlpha = 1.0;
    };
    
  };
  
  
}